/*
 ķ
   Program..: _DCPRES.PRG                           
   Author...: Roger J. Donnay                       
   Notice...: (c) DONNAY Software Designs 1987-2000 
   Date.....: Feb 18, 2000                          
   Notes....: Presentation functions                
 Ľ
*/

#include "_dcpres.ch"
#include "xbp.ch"
#include "gra.ch"
#include "dcdialog.ch"

FUNCTION DC_BrowPres( aPres, nFrame )
LOCAL aOldPres
STATIC aBrowPres := nil

if ValType(aBrowPres) <> "A"

  IF DC_BrowPresType() == 2 // thanks to Jack Duijf and his many hours of investigating Alaska source code

     aBrowPres         := {}
     //
     // Browse header
     //
     Aadd(aBrowPres,{ XBP_PP_COL_HA_FGCLR            , GRA_CLR_WHITE      })    // Header FG Color
     Aadd(aBrowPres,{ XBP_PP_COL_HA_BGCLR            , GRA_CLR_DARKGRAY   })    // Header BG Color
     Aadd(aBrowPres,{ XBP_PP_COL_HA_HEIGHT           , -1                 })    // Header Height in points
                                                                                // -1 Automatic by selected font.
     Aadd(aBrowPres,{ XBP_PP_COL_HA_COMPOUNDNAME     , "9.Arial"          })    // Header font
     //
     // Browse footer
     //
     Aadd(aBrowPres,{ XBP_PP_COL_FA_FGCLR            , GRA_CLR_WHITE      })    // Footer FG Color
     Aadd(aBrowPres,{ XBP_PP_COL_FA_BGCLR            , GRA_CLR_DARKGRAY   })    // Footer BG Color
     Aadd(aBrowPres,{ XBP_PP_COL_FA_COMPOUNDNAME     , "9.Arial"          })    // Footer font
     Aadd(aBrowPres,{ XBP_PP_COL_FA_HEIGHT           , -1                 })    // Footer Height in points
                                                                                // -1 Automatic by selected font.
     //
     // Browse data
     //
     Aadd(aBrowPres,{ XBP_PP_COL_DA_FGCLR            , GRA_CLR_BLACK      })    // Row FG Color
     Aadd(aBrowPres,{ XBP_PP_COL_DA_BGCLR            , GRA_CLR_WHITE      })    // Row BG Color
     Aadd(aBrowPres,{ XBP_PP_COL_DA_ROWHEIGHT        , -1                 })    // Row Height in points
     Aadd(aBrowPres,{ XBP_PP_COL_DA_COMPOUNDNAME     , "9.Arial"          })    // Data font
     Aadd(aBrowPres,{ XBP_PP_COL_DA_HILITE_FGCLR     , GRA_CLR_WHITE      })    // Hilite FG color
     Aadd(aBrowPres,{ XBP_PP_COL_DA_HILITE_BGCLR     , GRA_CLR_BLUE       })    // Hilite BG color
     Aadd(aBrowPres,{ XBP_PP_COL_DA_ROWSEPARATOR     , XBPCOL_SEP_DOTTED  })    // Row Seperator
     Aadd(aBrowPres,{ XBP_PP_COL_DA_COLSEPARATOR     , XBPCOL_SEP_DOTTED  })    // Col Seperator
     //
     // Zebra striping (Uncomment lines below to activate)
     //
     /*
     Aadd(aBrowPres,{XBP_PP_COL_ZEBRA_EVENROW_BGCLR  , GRA_CLR_YELLOW     })    // Zebra even row BG color
     Aadd(aBrowPres,{XBP_PP_COL_ZEBRA_EVENROW_FGCLR  , GRA_CLR_BLACK      })    // Zebra even row FG color
     Aadd(aBrowPres,{XBP_PP_COL_ZEBRA_ODDROW_BGCLR   , GRA_CLR_WHITE      })    // Zebra odd row BG color
     Aadd(aBrowPres,{XBP_PP_COL_ZEBRA_ODDROW_FGCLR   , GRA_CLR_BLACK      })    // Zebra odd row FG color
     Aadd(aBrowPres,{XBP_PP_COL_ZEBRA_ENABLED        , 1                  })    // Enable standard zebra colour
   */

  ELSE

   aBrowPres := ;
    { { XBP_PP_COL_HA_FGCLR, GRA_CLR_WHITE },            /* Header FG Color  */  ;
      { XBP_PP_COL_HA_BGCLR, GRA_CLR_DARKGRAY },         /* Header BG Color  */  ;
      { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED }, /* Row Sep          */  ;
      { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED }, /* Col Sep          */  ;
      { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },            /* Row FG Color     */  ;
      { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },            /* Row BG Color     */  ;
      { XBP_PP_COL_DA_ROWHEIGHT, 16 },                   /* Row Height       */  ;
      { XBP_PP_COL_HA_HEIGHT, 20 },                      /* Header Height    */  ;
      { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_WHITE },     /* Hilite FG color  */  ;
      { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_BLUE },      /* Hilite BG color  */  ;
      { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },            /* Footer FG Color  */  ;
      { XBP_PP_COL_FA_BGCLR, GRA_CLR_DARKGRAY },         /* Footer BG Color  */  ;
      { XBP_PP_COL_FA_HEIGHT, 10 }                       /* Footer Height    */  ;
  }

  ENDIF

endif
IF Valtype(nFrame) == 'N'
  AAdd( aBrowPres, { XBP_PP_COL_DA_HILITEFRAMELAYOUT, nFrame })
ENDIF

IF Valtype(aPres) = 'A'
   aOldPres := AClone(aBrowPres)
   aBrowPres := aPres
   RETURN aOldPres
ENDIF


RETURN aBrowPres

* -----------

GETSETFUNCTION DC_BrowPresType DEFAULT 1

* --------------

FUNCTION DC_BrowPresExpress( aPres )

LOCAL aOldPres

STATIC aBrowPres := ;
  { { XBP_PP_COL_HA_FGCLR, GRA_CLR_WHITE },            /* Header FG Color  */  ;
    { XBP_PP_COL_HA_BGCLR, GRA_CLR_DARKGRAY },         /* Header BG Color  */  ;
    { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED }, /* Row Sep          */  ;
    { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED }, /* Col Sep          */  ;
    { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },            /* Row FG Color     */  ;
    { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },            /* Row BG Color     */  ;
    { XBP_PP_COL_DA_ROWHEIGHT, 18 },                   /* Row Height       */  ;
    { XBP_PP_COL_HA_HEIGHT, -1 },                      /* Header Height    */  ;
    { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_WHITE },     /* Hilite FG color  */  ;
    { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_DARKBLUE },  /* Hilite BG color  */  ;
    { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },            /* Footer FG Color  */  ;
    { XBP_PP_COL_FA_BGCLR, GRA_CLR_DARKGRAY },         /* Footer BG Color  */  ;
    { XBP_PP_COL_FA_HEIGHT, -1 }                       /* Footer Height    */  ;
  }

IF Valtype(aPres) = 'A'
   aOldPres := AClone(aBrowPres)
   aBrowPres := aPres
   RETURN aOldPres
ENDIF
RETURN aBrowPres

* --------------------

FUNCTION DC_PresAdd( aPres, aItem )

LOCAL nFound

IF Empty(aPres)
  IF Valtype(aPres) = 'A'
    AAdd( aPres, aItem )
  ELSE
    aPres := { aItem }
  ENDIF
ELSE
  nFound := AScan( aPres, {|a,n|IIF(Valtype(a)='A',(n := a[1], Valtype(n) == 'N' .AND. n == aItem[1]),.f.) } )
  IF nFound > 0
    aPres[nFound] := aItem
  ELSE
    AAdd( aPres, aItem )
  ENDIF
ENDIF

RETURN aPres

* ------------------

FUNCTION DC_PresFix( aPres )

LOCAL nFound, nLen, aPres2, i, j

nLen := Len(aPres)
FOR i := 1 TO nLen
  IF Valtype(aPres[i,1]) = 'A'
    aPres2 := aPres[i]
    FOR j := 1 TO Len(aPres2)
      AAdd(aPres,aPres2[j])
    NEXT
    ARemove( aPres, i )
    i--
  ENDIF
NEXT

nLen := Len(aPres)
FOR i := 1 TO nLen
  IF ( nFound := AScan(aPres,{|a|a[1]==aPres[i,1]}, i+1 ) ) > 0
    ADel( aPres, nFound )
    ASize( aPres, Len(aPres)-1 )
    nLen--
  ENDIF
NEXT


RETURN aPres

* ------------------

FUNCTION DC_PresEdit( aPres, nMode )

LOCAL aPresGeneric, aPresMenu, aPresData, aPresHeader, aPresFooter, ;
      aPresTemp, GetList := {}, lOk, cPresCodeBlock

#define PRES_COLOR         1
#define PRES_FONT          2
#define PRES_SEP           3
#define PRES_PIXELS        4
#define PRES_ALIGN         5
#define PRES_CAPTION       6
#define PRES_LAYOUT        7

DEFAULT nMode := 0
IF Valtype(aPres) = 'C'
  cPresCodeBlock := Pad(aPres,100)
ELSE
  cPresCodeBlock := Space(100)
  DEFAULT aPres := {}
  aPresTemp := AClone(aPres)
ENDIF

aPresGeneric := { ;
  { XBP_PP_FGCLR, 'XBP_PP_FGCLR',  DCMSG_PP_FGCLR, PRES_COLOR, 0 }, ;
  { XBP_PP_BGCLR, 'XBP_PP_BGCLR',  DCMSG_PP_BGCLR, PRES_COLOR, 0 }, ;
  { XBP_PP_HILITE_FGCLR, 'XBP_PP_HILITE_FGCLR',  DCMSG_PP_HILITE_FGCLR, PRES_COLOR, 0 }, ;
  { XBP_PP_HILITE_BGCLR, 'XBP_PP_HILITE_BGCLR',  DCMSG_PP_HILITE_BGCLR, PRES_COLOR, 0 }, ;
  { XBP_PP_DISABLED_FGCLR, 'XBP_PP_DISABLED_FGCLR',  DCMSG_PP_DISABLED_FGCLR, PRES_COLOR, 0 }, ;
  { XBP_PP_DISABLED_BGCLR, 'XBP_PP_DISABLED_BGCLR',  DCMSG_PP_DISABLED_BGCLR, PRES_COLOR, 0 }, ;
  { XBP_PP_BORDER_CLR, 'XBP_PP_BORDER_CLR',  DCMSG_PP_BORDER_CLR, PRES_COLOR, 0 }, ;
  { XBP_PP_COMPOUNDNAME, 'XBP_PP_COMPOUNDNAME',  DCMSG_PP_COMPOUNDNAME, PRES_FONT, '' }, ;
  { XBP_PP_FONT, 'XBP_PP_FONT',  DCMSG_PP_FONT, PRES_FONT, '' }, ;
  { XBP_PP_ACTIVE_CLR, 'XBP_PP_ACTIVE_CLR',  DCMSG_PP_ACTIVE_CLR, PRES_COLOR, 0 }, ;
  { XBP_PP_INACTIVE_CLR, 'XBP_PP_INACTIVE_CLR',  DCMSG_PP_INACTIVE_CLR, PRES_COLOR, 0 }, ;
  { XBP_PP_ACTIVETEXT_FGCLR, 'XBP_PP_ACTIVETEXT_FGCLR',  DCMSG_PP_ACTIVETEXT_FGCLR, PRES_COLOR, 0 }, ;
  { XBP_PP_ACTIVETEXT_BGCLR, 'XBP_PP_ACTIVETEXT_BGCLR',  DCMSG_PP_ACTIVETEXT_BGCLR, PRES_COLOR, 0 }, ;
  { XBP_PP_INACTIVETEXT_FGCLR, 'XBP_PP_INACTIVETEXT_FGCLR',  DCMSG_PP_INACTIVETEXT_FGCLR, PRES_COLOR, 0 }, ;
  { XBP_PP_INACTIVETEXT_BGCLR, 'XBP_PP_INACTIVETEXT_BGCLR',  DCMSG_PP_INACTIVETEXT_BGCLR, PRES_COLOR, 0 }, ;
  { XBP_PP_CAPTION, 'XBP_PP_CAPTION',  DCMSG_PP_CAPTION, PRES_CAPTION, '' }, ;
  { XBP_PP_ALIGNMENT, 'XBP_PP_ALIGNMENT',  DCMSG_PP_ALIGNMENT, PRES_ALIGN, 0 } }

aPresMenu := { ;
  { XBP_PP_MENU_FGCLR, 'XBP_PP_MENU_FGCLR',  DCMSG_PP_FGCLR, PRES_COLOR, 0 }, ;
  { XBP_PP_MENU_BGCLR, 'XBP_PP_MENU_BGCLR',  DCMSG_PP_BGCLR, PRES_COLOR, 0 }, ;
  { XBP_PP_MENU_HILITE_FGCLR, 'XBP_PP_MENU_HILITE_FGCLR',  DCMSG_PP_HILITE_FGCLR, PRES_COLOR, 0 }, ;
  { XBP_PP_MENU_HILITE_BGCLR, 'XBP_PP_MENU_HILITE_BGCLR',  DCMSG_PP_HILITE_BGCLR, PRES_COLOR, 0 }, ;
  { XBP_PP_MENU_DISABLED_FGCLR, 'XBP_PP_MENU_DISABLED_FGCLR',  DCMSG_PP_DISABLED_FGCLR, PRES_COLOR, 0 }, ;
  { XBP_PP_MENU_DISABLED_BGCLR, 'XBP_PP_MENU_DISABLED_BGCLR',  DCMSG_PP_DISABLED_BGCLR, PRES_COLOR, 0 } }

aPresData := { ;
   { XBP_PP_COL_DA_FGCLR, 'XBP_PP_COL_DA_FGCLR',  DCMSG_PP_FGCLR, PRES_COLOR, 0 }, ;
   { XBP_PP_COL_DA_BGCLR, 'XBP_PP_COL_DA_BGCLR',  DCMSG_PP_BGCLR, PRES_COLOR, 0 }, ;
   { XBP_PP_COL_DA_HILITE_FGCLR, 'XBP_PP_COL_DA_HILITE_FGCLR',  DCMSG_PP_HILITE_FGCLR, PRES_COLOR, 0 }, ;
   { XBP_PP_COL_DA_HILITE_BGCLR, 'XBP_PP_COL_DA_HILITE_BGCLR',  DCMSG_PP_HILITE_BGCLR, PRES_COLOR, 0 }, ;
   { XBP_PP_COL_DA_COMPOUNDNAME, 'XBP_PP_COL_DA_COMPOUNDNAME',  DCMSG_PP_COMPOUNDNAME, PRES_FONT, '' }, ;
   { XBP_PP_COL_DA_ROWWIDTH, 'XBP_PP_COL_DA_ROWWIDTH',  DCMSG_PP_ROWWIDTH, PRES_PIXELS, 0 }, ;
   { XBP_PP_COL_DA_ROWHEIGHT, 'XBP_PP_COL_DA_ROWHEIGHT',  DCMSG_PP_ROWHEIGHT, PRES_PIXELS, 0 }, ;
   { XBP_PP_COL_DA_CELLWIDTH, 'XBP_PP_COL_DA_CELLWIDTH',  DCMSG_PP_CELLWIDTH, PRES_PIXELS, 0 }, ;
   { XBP_PP_COL_DA_CELLHEIGHT, 'XBP_PP_COL_DA_CELLHEIGHT',  DCMSG_PP_CELLHEIGHT, PRES_PIXELS, 0 }, ;
   { XBP_PP_COL_DA_CELLALIGNMENT, 'XBP_PP_COL_DA_CELLALIGNMENT',  DCMSG_PP_CELLALIGNMENT, PRES_ALIGN, 0 }, ;
   { XBP_PP_COL_DA_ROWSEPARATOR, 'XBP_PP_COL_DA_ROWSEPARATOR',  DCMSG_PP_ROWSEPARATOR, PRES_SEP, 0 }, ;
   { XBP_PP_COL_DA_COLSEPARATOR, 'XBP_PP_COL_DA_COLSEPARATOR',  DCMSG_PP_COLSEPARATOR, PRES_SEP, 0 }, ;
   { XBP_PP_COL_DA_FRAMELAYOUT, 'XBP_PP_COL_DA_FRAMELAYOUT',  DCMSG_PP_FRAMELAYOUT, PRES_LAYOUT, 0 }, ;
   { XBP_PP_COL_DA_CELLFRAMELAYOUT, 'XBP_PP_COL_DA_CELLFRAMELAYOUT',  DCMSG_PP_CELLFRAMELAYOUT, PRES_LAYOUT, 0 }, ;
   { XBP_PP_COL_DA_HILITEFRAMELAYOUT, 'XBP_PP_COL_DA_HILITEFRAMELAYOUT',  DCMSG_PP_HILITEFRAMELAYOUT, PRES_LAYOUT, 0 }, ;
   { XBP_PP_COL_DA_CHARWIDTH, 'XBP_PP_COL_DA_CHARWIDTH',  DCMSG_PP_CHARWIDTH, PRES_PIXELS, 0 } }

aPresHeader := { ;
   { XBP_PP_COL_HA_FGCLR, 'XBP_PP_COL_HA_FGCLR',  DCMSG_PP_FGCLR, PRES_COLOR, 0 }, ;
   { XBP_PP_COL_HA_BGCLR, 'XBP_PP_COL_HA_BGCLR',  DCMSG_PP_BGCLR, PRES_COLOR, 0 }, ;
   { XBP_PP_COL_HA_COMPOUNDNAME, 'XBP_PP_COL_HA_COMPOUNDNAME',  DCMSG_PP_COMPOUNDNAME, PRES_FONT, '' }, ;
   { XBP_PP_COL_HA_FRAMELAYOUT, 'XBP_PP_COL_HA_FRAMELAYOUT',  DCMSG_PP_FRAMELAYOUT, PRES_LAYOUT, 0 }, ;
   { XBP_PP_COL_HA_ALIGNMENT, 'XBP_PP_COL_HA_ALIGNMENT',  DCMSG_PP_ALIGNMENT, PRES_ALIGN, 0 }, ;
   { XBP_PP_COL_HA_HEIGHT, 'XBP_PP_COL_HA_HEIGHT',  DCMSG_PP_HEIGHT, PRES_PIXELS, 0 }, ;
   { XBP_PP_COL_HA_CAPTION, 'XBP_PP_COL_HA_CAPTION',  DCMSG_PP_CAPTION, PRES_CAPTION, '' } }

aPresFooter := { ;
   { XBP_PP_COL_FA_FGCLR, 'XBP_PP_COL_FA_FGCLR',  DCMSG_PP_FGCLR, PRES_COLOR, 0 }, ;
   { XBP_PP_COL_FA_BGCLR, 'XBP_PP_COL_FA_BGCLR',  DCMSG_PP_FGCLR, PRES_COLOR, 0 }, ;
   { XBP_PP_COL_FA_COMPOUNDNAME, 'XBP_PP_COL_FA_COMPOUNDNAME',  DCMSG_PP_COMPOUNDNAME, PRES_FONT, '' }, ;
   { XBP_PP_COL_FA_FRAMELAYOUT, 'XBP_PP_COL_FA_FRAMELAYOUT',  DCMSG_PP_FRAMELAYOUT, PRES_LAYOUT, 0 }, ;
   { XBP_PP_COL_FA_ALIGNMENT, 'XBP_PP_COL_FA_ALIGNMENT',  DCMSG_PP_ALIGNMENT, PRES_ALIGN, 0 }, ;
   { XBP_PP_COL_FA_HEIGHT, 'XBP_PP_COL_FA_HEIGHT',  DCMSG_PP_HEIGHT, PRES_PIXELS, 0 }, ;
   { XBP_PP_COL_FA_CAPTION, 'XBP_PP_COL_FA_CAPTION',  DCMSG_PP_CAPTION, PRES_CAPTION, '' } }

IF nMode = 0
  @ 1,1 DCPUSHBUTTON CAPTION DCMSG_PP_GENERIC SIZE 35,1.2 ;
        ACTION {||aPresTemp := _PresBrowse(aPresTemp,aPresGeneric)}
  @ 3,1 DCPUSHBUTTON CAPTION DCMSG_PP_HEADING SIZE 35,1.2 ;
        ACTION {||aPresTemp := _PresBrowse(aPresTemp,aPresHeader)}
  @ 5,1 DCPUSHBUTTON CAPTION DCMSG_PP_DATAAREA SIZE 35,1.2 ;
        ACTION {||aPresTemp := _PresBrowse(aPresTemp,aPresData)}
  @ 7,1 DCPUSHBUTTON CAPTION DCMSG_PP_FOOTING SIZE 35,1.2 ;
        ACTION {||aPresTemp := _PresBrowse(aPresTemp,aPresFooter)}
  @ 9,1 DCPUSHBUTTON CAPTION DCMSG_PP_MENU SIZE 35,1.2 ;
        ACTION {||aPresTemp := _PresBrowse(aPresTemp,aPresMenu)}
  @11,1 DCPUSHBUTTON CAPTION DCMSG_PP_CODEBLOCK SIZE 35,1.2 ;
        ACTION {||aPresTemp := _PresCodeBlock(@cPresCodeBlock)}
  @13,1 DCPUSHBUTTON CAPTION DCMSG_PP_SOURCECODE SIZE 35,1.2 ;
        ACTION {||_PresSourceCode(aPresTemp,{aPresGeneric,aPresHeader,;
                                  aPresData,aPresFooter,aPresMenu})}

  DCREAD GUI EXPRESS FIT ADDBUTTONS TO lOK MODAL ;
     TITLE DCMSG_PP_TITLE EVAL {|o|SetAppWindow(o)}
  IF lOk
    aPres := aPresTemp
  ENDIF
ENDIF

RETURN IIF( !Empty(cPresCodeBlock),cPresCodeBlock,aPres)

* ---------------------

STATIC FUNCTION _PresSourceCode( aPres, aTemplates )

LOCAL aTemplate := {}, i, j, nFound, cSource, cDesc, cName, ;
      cSourceFile, GetList := {}, lOk, xValue, cValue, oSource

FOR i := 1 TO Len(aTemplates)
  FOR j := 1 TO Len(aTemplates[i])
     AAdd(aTemplate, aTemplates[i,j])
  NEXT
NEXT

cSource := 'aPP := { ; ' + Chr(13)+Chr(10)

FOR i := 1 TO Len(aPres)
  nFound := AScan( aTemplate, {|a|a[1]==aPres[i,1]})
  IF nFound > 0
    cName := aTemplate[nFound,2]
    cDesc := aTemplate[nFound,3]
  ELSE
    cName := DC_XtoC(aPres[i,1])
    cDesc := 'unknown'
  ENDIF
  xValue := aPres[i,2]
  IF Valtype(xValue) = 'C'
    cValue := '"' + xValue + '"'
  ELSE
    cValue := DC_XtoC(xValue)
  ENDIF

  cSource += '{ ' + cName + ', ' + cValue + '} // ' + cDesc + ';' + ;
              + Chr(13)+Chr(10)
NEXT

cSource += '}' + Chr(13)+Chr(10)

cSourceFile := Space(50)
@ 0,0 DCSAY 'Source File Name' GET cSourceFile SAYRIGHT ;
      VALID {||DC_ReadEmpty(cSourceFile)} GETOBJECT oSource

@ 1.1,0 DCMULTILINE cSource SIZE 80,10 FONT '8.Courier'

DCREAD GUI EXPRESS FIT ADDBUTTONS TO lOk MODAL ;
   TITLE 'Save PP to Source Code' ;
   SETFOCUS @oSource

IF lOk .AND. !Empty(cSourceFile)
  MemoWrit( cSourceFile, cSource )
ENDIF

RETURN cSource

* ---------------------

STATIC FUNCTION _PresCodeBlock( cPresCodeBlock )

LOCAL GetList := {}

@ 0,0 DCSAY 'Enter a Code Block that returns an Array'
@ 1,0 DCGET cPresCodeBlock GETSIZE 40 ;
      VALID {||DC_ValidateBlock(cPresCodeBlock,'A')}

DCREAD GUI EXPRESS FIT ADDBUTTONS MODAL ENTEREXIT ;
   TITLE 'Presentation Parameters Code Block'

RETURN cPresCodeBlock

* ---------------------

STATIC FUNCTION _PresBrowse( aPres, aPresDefault )

LOCAL i, aPresTemp, nFound, nPointer := 1, GetList := {}, oBrowse, lOk

aPresTemp := AClone(aPres)
FOR i := 1 TO Len(aPresDefault)
  nFound := AScan(aPres,{|a|Valtype(a)=='N'.AND.a[1]==aPresDefault[i,1]})
  IF nFound > 0
    aPresDefault[i,5] := aPres[nFound,2]
  ENDIF
NEXT

@ 0,0 DCBROWSE oBrowse DATA aPresDefault SIZE 80,Max(10,Len(aPresDefault)-2);
      POINTER nPointer ;
      PRESENTATION DC_BrowPres() ;
      DATALINK {||_PresEdit(aPres,aPresDefault,nPointer,oBrowse)}

DCBROWSECOL ELEMENT 3 HEADER DCMSG_PP_DESC WIDTH 18 PARENT oBrowse
DCBROWSECOL ELEMENT 5 HEADER DCMSG_PP_SETVALUE WIDTH 5 PARENT oBrowse
DCBROWSECOL ELEMENT 1 HEADER DCMSG_PP_NUMERIC WIDTH 6 PARENT oBrowse
DCBROWSECOL ELEMENT 2 HEADER DCMSG_PP_DEFINE WIDTH 25 PARENT oBrowse
DCREAD GUI EXPRESS FIT ADDBUTTONS MODAL TO lOk ENTEREXIT ;
   TITLE DCMSG_PP_BROWINSTRUCT EVAL {|o|SetAppWindow(o)}

IF lOk
  RETURN aPres
ENDIF

RETURN aPresTemp

* ---------------

STATIC FUNCTION _PresEdit( aPres, aPresDefault, nPointer, oBrowse )

LOCAL GetList := {}, nType, bPopUp, xValue, lOk

nType := aPresDefault[nPointer,4]
xValue := aPresDefault[nPointer,5]
IF nType = PRES_COLOR
  bPopUp := {|n|DC_PopColor(n,2)}
  DEFAULT xValue := 0
ELSEIF nType = PRES_FONT
  bPopUp := {|c|DC_PopFont(c)}
  DEFAULT xValue := ''
  xValue := Pad(xValue,40)
ELSEIF nType = PRES_SEP
  bPopUp := {|n|DC_PopPresSep(n)}
  DEFAULT xValue := 0
ELSEIF nType = PRES_PIXELS
  DEFAULT xValue := 0
ELSEIF nType = PRES_ALIGN
  bPopUp := {|n|DC_PopPresAlign(n)}
  DEFAULT xValue := 0
ELSEIF nType = PRES_CAPTION
  DEFAULT xValue := ''
  xValue := Pad(xValue,40)
ELSEIF nType = PRES_LAYOUT
  bPopUp := {|n|DC_PopPresLayout(n)}
  DEFAULT xValue := 0
ENDIF

@ 0,0 DCSAY aPresDefault[nPointer,3] GET xValue POPUP bPopUp SAYSIZE 0

DCREAD GUI EXPRESS FIT ADDBUTTONS TO lOk TITLE DCMSG_PP_EDITINSTRUCT ;
   MODAL ENTEREXIT EVAL {|o|SetAppWindow(o)}

IF lOk
  IF Valtype(xValue) = 'C'
    xValue := Alltrim(xValue)
  ENDIF
  DC_PresAdd( aPres, { aPresDefault[nPointer,1], xValue } )
  aPresDefault[nPointer,5] := xValue
  oBrowse:refreshCurrent()
ENDIF

RETURN lOk

* --------------------

FUNCTION DC_PopPresLayout( nLayout )

LOCAL GetList := {}, lOk, aLayout[7]

aLayout[1] := DC_BitTest(nLayout,1)  // rect
aLayout[2] := DC_BitTest(nLayout,2)  // box
aLayout[3] := DC_BitTest(nLayout,5)  // raised
aLayout[4] := DC_BitTest(nLayout,6)  // recessed
aLayout[5] := DC_BitTest(nLayout,8)  // thick
aLayout[6] := DC_BitTest(nLayout,9,.t.)  // dashed
aLayout[7] := DC_BitTest(nLayout,10,.t.) // dotted

@ 1,1 DCCHECKBOX aLayout[1] PROMPT DCMSG_PP_LAYOUT_RECT
@ 2,1 DCCHECKBOX aLayout[2] PROMPT DCMSG_PP_LAYOUT_BOX
@ 3,1 DCCHECKBOX aLayout[3] PROMPT DCMSG_PP_LAYOUT_RAISED
@ 4,1 DCCHECKBOX aLayout[4] PROMPT DCMSG_PP_LAYOUT_RECESSED
@ 5,1 DCCHECKBOX aLayout[5] PROMPT DCMSG_PP_LAYOUT_THICK
@ 6,1 DCCHECKBOX aLayout[6] PROMPT DCMSG_PP_LAYOUT_DASHED
@ 7,1 DCCHECKBOX aLayout[7] PROMPT DCMSG_PP_LAYOUT_DOTTED

DCREAD GUI EXPRESS FIT ADDBUTTONS MODAL TO lOk TITLE DCMSG_PP_LAYOUT_TITLE

IF lOk
  nLayout := 0
  IF aLayout[1]
    nLayout += XBPFRAME_RECT
  ENDIF
  IF aLayout[2]
    nLayout += XBPFRAME_BOX
  ENDIF
  IF aLayout[3]
    nLayout += XBPFRAME_RAISED
  ENDIF
  IF aLayout[4]
    nLayout += XBPFRAME_RECESSED
  ENDIF
  IF aLayout[5]
    nLayout += XBPFRAME_THICK
  ENDIF
  IF aLayout[6]
    nLayout += XBPFRAME_DASHED
  ENDIF
  IF aLayout[7]
    nLayout += XBPFRAME_DOTTED
  ENDIF
ENDIF

RETURN nLayout

* --------------------

FUNCTION DC_PopPresAlign( nAlign )

LOCAL GetList := {}, aAlign[5], oStatic1, oStatic2, lOk

aAlign[1] := DC_BitTest( nAlign, 1 )  // hcenter
aAlign[2] := DC_BitTest( nAlign, 2 )  // right
aAlign[3] := DC_BitTest( nAlign, 3 )  // vcenter
aAlign[4] := DC_BitTest( nAlign, 4 )  // bottom
aAlign[5] := DC_BitTest( nAlign, 5 ) // wordbreak

@ 1,1 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT SIZE 30,3 OBJECT oStatic1
@ 0,1 DCRADIO aAlign[4] VALUE .f. PROMPT DCMSG_PP_ALIGN_TOP PARENT oStatic1
@ 1,1 DCRADIO aAlign[4] VALUE .t. PROMPT DCMSG_PP_ALIGN_BOTTOM PARENT oStatic1

@ 4,1 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT SIZE 30,3 OBJECT oStatic2
@ 0,1 DCRADIO aAlign[2] VALUE .f. PROMPT DCMSG_PP_ALIGN_LEFT PARENT oStatic2
@ 1,1 DCRADIO aAlign[2] VALUE .t. PROMPT DCMSG_PP_ALIGN_RIGHT PARENT oStatic2

@ 7,2 DCCHECKBOX aAlign[1] PROMPT DCMSG_PP_ALIGN_HCENTER
@ 8,2 DCCHECKBOX aAlign[3] PROMPT DCMSG_PP_ALIGN_VCENTER
@ 9,2 DCCHECKBOX aAlign[5] PROMPT DCMSG_PP_ALIGN_WORDBREAK

DCREAD GUI EXPRESS FIT ADDBUTTONS TO lOk TITLE DCMSG_PP_ALIGN_TITLE

IF lOk
  nAlign := 0
  IF aAlign[1]
    nAlign += XBPALIGN_HCENTER
  ENDIF
  IF aAlign[2]
    nAlign += XBPALIGN_RIGHT
  ENDIF
  IF aAlign[3]
    nAlign += XBPALIGN_VCENTER
  ENDIF
  IF aAlign[4]
    nAlign += XBPALIGN_BOTTOM
  ENDIF
  IF aAlign[5]
    nAlign += XBPALIGN_WORDBREAK
  ENDIF
ENDIF

RETURN nAlign

* --------------------

FUNCTION DC_PopPresSep( nSep )

LOCAL GetList := {}

@ 1,1 DCRADIO nSep VALUE XBPCOL_SEP_NONE PROMPT DCMSG_PP_SEP_NONE
@ 2,1 DCRADIO nSep VALUE XBPCOL_SEP_LINE PROMPT DCMSG_PP_SEP_LINE
@ 3,1 DCRADIO nSep VALUE XBPCOL_SEP_DASHED PROMPT DCMSG_PP_SEP_DASHED
@ 4,1 DCRADIO nSep VALUE XBPCOL_SEP_DOTTED PROMPT DCMSG_PP_SEP_DOTTED

DCREAD GUI EXPRESS FIT ADDBUTTONS MODAL TITLE DCMSG_PP_SEP_TITLE

RETURN nSep

* ----------------------

FUNCTION DC_PopPresBorder( nBorder )

LOCAL GetList := {}

@ 1,1 DCRADIO nBorder VALUE XBPDLG_NO_BORDER PROMPT DCMSG_XBPDLG_NO_BORDER
@ 2,1 DCRADIO nBorder VALUE XBPDLG_SIZEBORDER PROMPT DCMSG_XBPDLG_SIZEBORDER
@ 3,1 DCRADIO nBorder VALUE XBPDLG_THINBORDER PROMPT DCMSG_XBPDLG_THINBORDER
@ 4,1 DCRADIO nBorder VALUE XBPDLG_DLGBORDER PROMPT DCMSG_XBPDLG_DLGBORDER
@ 5,1 DCRADIO nBorder VALUE XBPDLG_RAISEDBORDERTHICK PROMPT DCMSG_XBPDLG_RAISEDBORDERTHICK
@ 6,1 DCRADIO nBorder VALUE XBPDLG_RAISEDBORDERTHIN PROMPT DCMSG_XBPDLG_RAISEDBORDERTHIN
@ 7,1 DCRADIO nBorder VALUE XBPDLG_RECESSEDBORDERTHICK PROMPT DCMSG_XBPDLG_RECESSEDBORDERTHICK
@ 8,1 DCRADIO nBorder VALUE XBPDLG_RECESSEDBORDERTHIN PROMPT DCMSG_XBPDLG_RECESSEDBORDERTHIN
@ 9,1 DCRADIO nBorder VALUE XBPDLG_RAISEDBORDERTHICK_FIXED PROMPT DCMSG_XBPDLG_RAISEDBORDERTHICK_FIXED
@10,1 DCRADIO nBorder VALUE XBPDLG_RAISEDBORDERTHIN_FIXED PROMPT DCMSG_XBPDLG_RAISEDBORDERTHIN_FIXED
@11,1 DCRADIO nBorder VALUE XBPDLG_RECESSEDBORDERTHICK_FIXED PROMPT DCMSG_XBPDLG_RECESSEDBORDERTHICK_FIXED
@12,1 DCRADIO nBorder VALUE XBPDLG_RECESSEDBORDERTHIN_FIXED PROMPT DCMSG_XBPDLG_RECESSEDBORDERTHIN_FIXED

DCREAD GUI EXPRESS FIT ADDBUTTONS MODAL TITLE DCMSG_XBPDLG_BORDER_TITLE

RETURN nBorder

* ----------------------

FUNCTION DC_Color2Attr( anColorFG, anColorBG, nWhich )

LOCAL aAttr

DEFAULT nWhich := GRA_AS_COUNT

IF Valtype(anColorFG) == 'B'
  anColorFG := Eval(anColorFG)
ENDIF

IF Valtype(anColorFG) == 'A' .AND. Len(anColorFG) == 3
  anColorFG := GraMakeRGBColor(anColorFG)
ENDIF

IF Valtype(anColorBG) == 'A' .AND. Len(anColorBG) == 3
  anColorBG := GraMakeRGBColor(anColorBG)
ENDIF

aAttr := Array(nWhich)

IF nWhich == GRA_AS_COUNT  // text
  IF Valtype(anColorFG) == 'N'
    aAttr[GRA_AS_COLOR] := anColorFG
  ENDIF
  IF Valtype(anColorBG) == 'N'
    aAttr[GRA_AS_BACKCOLOR] := anColorBG
    aAttr[GRA_AS_BGMIXMODE] := GRA_BGMIX_OVERPAINT
  ENDIF
ELSEIF nWhich == GRA_AA_COUNT // area
  IF Valtype(anColorFG) == 'N'
    aAttr[GRA_AA_COLOR] := anColorFG
  ENDIF
  IF Valtype(anColorBG) == 'N'
    aAttr[GRA_AA_BACKCOLOR] := anColorBG
  ENDIF
  aAttr[GRA_AA_BGMIXMODE] := GRA_BGMIX_OVERPAINT
ELSEIF nWhich == GRA_AM_COUNT // marker
  IF Valtype(anColorFG) == 'N'
    aAttr[GRA_AM_COLOR] := anColorFG
  ENDIF
  IF Valtype(anColorBG) == 'N'
    aAttr[GRA_AM_BACKCOLOR] := anColorBG
  ENDIF
  aAttr[GRA_AM_BGMIXMODE] := GRA_BGMIX_OVERPAINT
ELSEIF nWhich == GRA_AL_COUNT // line
  IF Valtype(anColorFG) == 'N'
    aAttr[GRA_AL_COLOR] := anColorFG
  ENDIF
ENDIF

RETURN aAttr
